/*
			Copyright (c) 1994 by
			Advanced Visual Systems Inc.
			All Rights Reserved
	
	This software comprises unpublished confidential information of
	Advanced Visual Systems Inc. and may not be used, copied or made
	available to anyone, except in accordance with the license
	under which it is furnished.
	
	This file is under Perforce control
	$Id: //depot/express/fcs992/modules/xfm_pln.c#1 $
*/
#include <avs/util.h>
#include <avs/err.h>
#include <avs/db.h>
#include <avs/fld.h>
#include <avs/math.h>

#define ERR_RETURN(A) ERRerror("slice",1,ERR_ORIG, A); return(0);

xform_plane(elem_id)
    OMobj_id elem_id;
{
	OMobj_id plane_id, x_rot_id, y_rot_id, z_rot_id, dist_id;
	double x_rot, y_rot, z_rot, dist;


	plane_id = OMfind_subobj(elem_id, OMstr_to_name("plane"),OM_OBJ_RW);
	x_rot_id = OMfind_subobj(elem_id, OMstr_to_name("x_rot"),OM_OBJ_RD);
	y_rot_id = OMfind_subobj(elem_id, OMstr_to_name("y_rot"),OM_OBJ_RD);
	z_rot_id = OMfind_subobj(elem_id, OMstr_to_name("z_rot"),OM_OBJ_RD);
	dist_id = OMfind_subobj(elem_id, OMstr_to_name("dist"),OM_OBJ_RD);

	OMget_real_val(x_rot_id, &x_rot);
	OMget_real_val(y_rot_id, &y_rot);
	OMget_real_val(z_rot_id, &z_rot);
	OMget_real_val(dist_id, &dist);

	if (!FUNCxform_plane(plane_id, (float)x_rot, (float)y_rot, (float)z_rot, (float)dist)) {
		fprintf (stderr, "\n**xform plane returns 0**\n");
	}

	return(1);
}

FUNCxform_plane(plane, x_rot, y_rot, z_rot, dist)
    OMobj_id plane;
    float x_rot, y_rot, z_rot, dist;
{
	float  cx, cy, cz;
	float mat[4][4], tmat[4][4];
	float *pnts, *xform;
	int  npts, size, i;

	if (!FLDget_xform(plane, &xform, OM_GET_ARRAY_WR)) {
		ERR_RETURN("Error getting xform");
	}

	if (!FLDget_points_unif (plane, &pnts, &npts, &size, OM_GET_ARRAY_RD)) {
		ERR_RETURN("Error getting points");
	}
	cx = 0.5*(pnts[0]+pnts[3]);
	cy = 0.5*(pnts[1]+pnts[4]);
	cz = 0.5*(pnts[2]+pnts[5]);
	
	MATmat4_translate (mat, -cx, -cy, -cz + dist);
	MATmat4_x_rotate (x_rot, tmat);
	MATmat4_multiply (mat, tmat, mat);
	MATmat4_y_rotate (y_rot, tmat);
	MATmat4_multiply (mat, tmat, mat);
	MATmat4_translate (tmat, cx, cy, cz);
	MATmat4_multiply (mat, tmat, mat);

	for (i=0; i<4; i++)
		memcpy(xform+i*4, mat[i], 4*sizeof(float));
	return(1);
}

